#include "RBP2.inc"   ;include file with mem equates

.org _asm_exec_ram    ;start address for ALL asm programs
 
 nop                  ;no operation
 jp Delete_Variables  ;if executed from a shell,goto 'Delete_Variables' label
 .dw 0                ;no shell picture
 .dw ShellTitle       ;ptr to title string
 
ShellTitle: .db "DelVars v1.0 by Matt Manning" ;title for shells--zero terminated
numvars: ;counter for vars,also the zero terminus of the 'ShellTitle' string :-)
.db 0
 
Delete_Variables:
 xor a                 ;\ Initializes var counter
 ld (numvars),a        ;/
 ld hl,_LASTENTRYSTK   ;\ Resets the entry stack where entries are stored
 ld (_LASTENTRYPTR),hl ;/
 ld hl,0
 push hl
 push hl
 ld (_numlastentries),hl  ;Resets the # of entries and the current entry to zero
 call _EXCNAME       ;\
 rst 10h             ;  \
 call nc,_delvar     ;    > Update '!' variable \
 pop hl              ;  /                         \
 call _createprog    ;/                             \  These vars MUST be on the calc
 call _LBNAME        ;\                             /  or else the calc crashes!
 rst 10h             ;  \                         /
 call nc,_delvar     ;    > Update '#' variable /
 pop hl              ;  /
 call _createprog    ;/
 call _clrScrn
 call _homeup
 call _flushallmenus
 ld b,17
 ld hl,var_table      ;begin searching for variables
loop: 
 push bc              ;save loop counter
 push hl              ;save ptr to variable type
 rst 20h
 call Trash_Variable  ;trash all vars of type in (hl)
 pop hl               ;restore ptr
 inc hl               ;\
 inc hl               ; > Increment counter by 3 to point to next var type
 inc hl               ;/  for the next loop
 pop bc               ;restore loop counter
 djnz loop            ;loop again!
 call _delhooks       ;delete square root programs (hooks)
 call _chk_for_ans    ;check for the 'Ans' variable and delete it
 call _statplotinit   ;reset stat plots
 call _clrNames       ;clear list editor
 call _grReset        ;reset graphing defaults
 call _CLEANALL       ;delete all temp vars
 set 3,(iy+$05)
 ld hl,deltext
 call _puts
 call _newline
 ld hl,_txt_MEM_FR    ;\
 call _puts           ;  \
 call _memchk         ;    \ Print available memory
 call _dispAHL        ;    /
 ld hl,deltext3       ;  /
 call _puts           ;/
 ld a,(numvars)       ;\
 ld h,0               ;  \
 ld l,a               ;    > Retrieve var counter and display 
 xor a                ;  /   number of deleted vars
 call _dispAHL        ;/
 ld a,Lspace
 call _putc
 ld hl,_txt_VARS
 call _puts
 ld a,Lspace
 call _putc
 ld hl,_txt_DELETE
 call _puts
 ld hl,deltext2
 call _puts
 call _newline
 call $001b       ;clear graph memory
 res 3,(iy+$05)
 res 5,(iy+$00)   ;eliminate the 'Done' message
 ret              ;return to tiOS

Trash_Variable:
 xor a
 call _FindAlphaUp    ;search by type
 ret c                ;if no more vars of type are found,return
 call _ckop1real      ;get type of var in _OP1
 cp $0c               ;check for string
 jr z,Trash_Variable  ;if it is,don't delete it
 cp $12               ;check for program
 jr nz,skip           ;if not,skip it
 jr check_bytes       ;if it is,check type of program
skip:
 ld hl,numvars        ;\ Increment var counter
 inc (hl)             ;/
 ld a,5
 call _putc
 call _dspnameOp1     ;display name of var
 ld a,$0c
 ld (_curCol),a
 ld a,(_OP1)
 call _get_var_type    ;convert var type to string and display
 call _puts
 call _newline
 rst 10h              ;find var in _OP1
 call _delvar         ;delete var in _OP1
 jr Trash_Variable    ;loop again
  
_chk_for_ans:
 ld hl,ansvar-1       ;\
 rst 20h              ;  \
 rst 10h              ;    > Look for the 'Ans' var and delete it 
 ret c                ;  /   if it exists,otherwise return
 jr skip              ;/
 
check_bytes:
 rst 10h
 push bc
 push de
 call _COMPILE  ;tokenize it if it is a BASIC program
 pop de
 pop bc
 call _ex_ahl_bde      ;swap ahl and bde
 call _ahl_plus_2_pg3  ;ahl = ahl + 2
 call _get_word_ahl    ;de = (ahl),ahl = ahl + 2
 ld a,e
 cp $8e                ;check for asm or edit-lock byte
 jr nz,skip            ;if not,it's a BASIC prog--so delete it!
 ld a,d
 cp $28                ;check for compiled asm prog
 jr z,Trash_Variable   ;if it is,skip it
 cp $27                ;check for the 'AsmPrgm' hex prog
 jr z,Trash_Variable   ;if so,skip it--it's an asm prog
 jr skip               ;if not,it is an edit-locked BASIC prog--so delete it!
   
_get_var_type:
 ld hl,type_table     ;\
 add a,a              ;  \  
 ld c,a               ;    \ Converts var tpye to a string in (hl)
 ld b,0               ;    /
 add hl,bc            ;  /
 jp _ldhlind          ;/
 
_delhooks:   ;this routine deletes the square root programs.
 ld hl,sqrt_table
 ld b,8
delete_hook: ;deletes hooks if they exist
 push bc
 push hl
 call _ldhlind
 rst 20h
 rst 10h
 call nc,deleteit
 pop hl
 inc hl
 inc hl
 pop bc
 djnz delete_hook
 res 6,(iy+$23)     ;Reset hook flags
 ld (iy+$24),0
 ret
 
deleteit: 
 call _delvar   ;delete sqrt prog
 ld hl,numvars  ;\ increment var counter
 inc (hl)       ;/
 ld a,5
 call _putc
 call _dspnameOp1 ;display var name
 ld a,$0c
 ld (_curCol),a
 ld hl,_txt_PRGM
 call _puts
 call _newline
 ret 
 
_clrNames:         ;clears list editor and resets edit cursor to first list
 ld hl,_NumCurList
 ld de,_NumCurList+1
 ld bc,_LastName-_NumCurList
 ld (hl),b
 ldir
 ret
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          
var_table: ;table of var types--Syntax: .db vartype,1,0 **SEE BELOW FOR VAR TYPES**
.db 0,1,0,1,1,0,2,1,0,3,1,0,4,1,0,5,1,0,6,1,0,7,1,0,8,1,0
.db 9,1,0,$0a,1,0,$0d,1,0,$0e,1,0,$0f,1,0,$10,1,0,$11,1,0
.db $12,1,0
;table of addresses of square root program strings
sqrt_table:
.dw $5988   ;--> (sqrt)EXPR
.dw $59b3   ;--> (sqrt)PARSE
.dw $59f4   ;--> (sqrt)EXEC
.dw $5a13   ;--> (sqrt)FORM
.dw $5a37   ;--> (sqrt)CMDTOK
.dw $5a69   ;--> (sqrt)HOME
.dw $5a92   ;--> (sqrt)KEY
.dw $5ab6   ;--> (sqrt)GRF
;table of addresses of var type strings
type_table:
.dw _txt_REAL   ;"REAL"  --> Real Variable    (type $00)
.dw _txt_CPLX   ;"CPLX"  --> Complex Variable (type $01)
.dw _txt_VECR   ;"VECTR" --> Real Vector      (type $02)
.dw _txt_VECR   ;"VECTR" --> Complex Vector   (type $03)
.dw _txt_LIST   ;"LIST"  --> Real List        (type $04)
.dw _txt_LIST   ;"LIST"  --> Complex List     (type $05)
.dw _txt_MATRX  ;"MATRX" --> Real Matrix      (type $06)
.dw _txt_MATRX  ;"MATRX" --> Complex Matrix   (type $07)
.dw _txt_CONS   ;"CONS"  --> Real Constant    (type $08)
.dw _txt_CONS   ;"CONS"  --> Complex Constant (type $09)
.dw _txt_EQUsp  ;"EQU"   --> Equation         (type $0a)
.dw 0           ;None    --> SYSTEM VAR       (type $0b)  **Not Searched For**
.dw _txt_STRNG  ;"STRNG" --> String           (type $0c)
.dw FGdb        ;"fGDB"  --> Function GDB     (type $0d)
.dw PLGdb       ;"plGDB" --> Polar GDB        (type $0e)
.dw PRGdb       ;"prGDB" --> Parametric GDB   (type $0f)
.dw DGdb        ;"dGDB"  --> Differential GDB (type $10)
.dw _txt_PICsp  ;"PIC"   --> Picture Variable (type $11)
.dw _txt_PRGM   ;"PRGM"  --> Program Variable (type $12)
;Miscellaneous strings 
FGdb: .db "fGDB",0
PLGdb: .db "plGDB",0
PRGdb: .db "prGDB",0
DGdb: .db "dGDB",0
ansvar:
.db 3,"Ans"
deltext:
.db "Entries Cleared.",0
deltext2:
.db "D.",0 ;follows the "DELETE" string at address $256f
deltext3:
.db " BYTES.",0 ;follows the "MEM FREE" string at address $262f and the # bytes free

.end  ;end of program